from __future__ import nested_scopes

from AccessControl import ClassSecurityInfo
from Globals import InitializeClass
from OFS.SimpleItem import SimpleItem

from Products.Silva import SilvaPermissions
from Products.Silva import mangle

from Products.SilvaDocument.EditorSupportNested import EditorSupport
from Products.SilvaDocument.mixedcontentsupport import SupportRegistry,PreSupport

#local mcs that overrides SilvaDocument's mixed content support...hehehe, sneaky!
import mixedcontentsupport

mixedContentSupportRegistry = SupportRegistry(mixedcontentsupport.ParagraphSupport)
mixedContentSupportRegistry.registerElementDefault('heading',mixedcontentsupport.HeadingSupport)
mixedContentSupportRegistry.registerElementDefault('pre',PreSupport)
mixedContentSupportRegistry.registerElementDefault('label',mixedcontentsupport.FormLabelSupport)

class EditorSupportError(Exception):
    pass

class CustomEditorSupport(EditorSupport):
    """XML editor support. """
    
    security = ClassSecurityInfo()

    meta_type = 'Silva Custom Editor Support Service'
    title = 'Custom Editor Support Service'

    security.declareProtected(
        SilvaPermissions.AccessContentsInformation, 'getMixedContentSupport')
    def getMixedContentSupport(self, context, node):
        supportklass = mixedContentSupportRegistry.lookup(context, node)
        return supportklass(node).__of__(context)

InitializeClass(CustomEditorSupport)

def manage_addCustomEditorSupport(container):
    "editor support service factory"
    id = 'service_editorsupport'
    container._setObject(id, CustomEditorSupport(id))

